
--[[
	  y-axis
		 |
		 o_ x-axis
		/
	  z-axis
--]]	

axis={

	rx=0.5,-- rotation about X axis
	ry=0,-- rotation about Y axis

	x_sx=0,--x scale factor OF the X axis
	x_sy=0,--y scale factor OF the X axis
	z_sx=0,--x scale factor OF the Z axis
	z_sy=0,--y scale factor OF the Z axis
	y_sy=0,--y scale factor OF the Y axis

	zr=0,-- visual rotation of Z axis
	xr=0,-- visual rotation of X axis
	
	last_vaiable='unused' -- unused
}

function axis.load(axis)

	function axis.draw(axis,cx,cy,r)
	
		local lgl=love.graphics.line
		--right
		lgl(cx,cy,cx+r*axis.x_sx,cy+r*axis.x_sy)

		--front
		lgl(cx,cy,cx+r*axis.z_sx,cy+r*axis.z_sy)

		--down
		lgl(cx,cy,cx,cy+r*axis.y_sy)
		
	end


	function axis.update(axis,dt)
	--UPDATE (dt)
	--set up nicknames, remember to updated the originals at the end.

		local rx=axis.rx
		local ry=axis.ry

	-- rotate axis (based on keyboard)
		local lkd=love.keyboard.isDown	
		if lkd('down') then rx=rx+dt end
		if lkd('up') then rx=rx-dt end
		if lkd('left') then ry=ry-dt end
		if lkd('right') then ry=ry+dt end	

	-- keep rotations within bounds	
		if rx>2 then rx=rx-2 elseif rx<0 then rx=rx+2 end
		if ry>2 then ry=ry-2 elseif ry<0 then ry=ry+2 end

	--update global variables
		axis.rx=rx
		axis.ry=ry
		
	-- scale factors
		local cos=math.cos
		local sin=math.sin
		local pi=math.pi
		
		rx=axis.rx*pi
		ry=axis.ry*pi

		local x_sx= cos(ry)
		local x_sy= sin(rx)*sin(ry)*-1
		local z_sx= sin(ry)
		local z_sy= sin(rx)*cos(ry)
		local y_sy= cos(rx)
		

	-- visaul rotation
		
		local atan=math.atan
		local zr=atan(z_sy/z_sx)
		local xr=atan(x_sy/x_sx)
		
		ry=axis.ry
		
		---[[problem if ry exactly at 1.5?
		if ry>0.5 and ry<1.0 then xr=xr+pi end
		if ry>1.0 and ry<1.5 then zr=zr+pi  xr=xr-pi end
		if ry>1.5 and ry<2 then zr=zr-pi end
		--]]

	--update originals
		axis.ry=ry
		--axis.rx=rx
		
		axis.x_sx=x_sx
		axis.x_sy=x_sy
		--axis.y_sx=
		axis.y_sy=y_sy
		axis.z_sx=z_sx
		axis.z_sy=z_sy
		
		axis.zr=zr
		axis.xr=xr
		
		--lengthts of axes
		axis.zl=math.sqrt(z_sx^2+z_sy^2)
		axis.xl=math.sqrt(x_sx^2+x_sy^2)
		--math.cos(math.pi*(0.5+axis.zr))*axis.zl
		
	end
	
end

